#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <winsock.h>
#include <time.h>
#include "resource.h"

#define ID_EDIT_SERVER	1000
#define ID_GET			1001
#define ID_SYNC			1002
#define ID_EDIT_CUR		1003
#define ID_EDIT_NTP		1004

#define WSOCK_GETHOST	WM_USER + 1	/* zXg̃Cxgʒm郁bZ[W */
#define WSOCK_SELECT	WM_USER + 2	/* \PbgCxgʒm郁bZ[W */

#define BUFSIZE			256			/* obt@TCY */

#define TIMER_ID		1			/* ^C}[ID */

// global
HINSTANCE g_hinst;					/* AvP[ṼCX^Xnh */
BOOL sync_flag;						/* tO */

char gHostEnt[MAXGETHOSTSTRUCT];	/* zXg擾obt@ */
HANDLE hGetHost;					/* zXg擾Ƃ̔񓯊ȃ^XÑnh */
int soc;							/* \PbgiSoket Descriptorj */
char SvName[BUFSIZE];				/* T[o */
int Port;							/* |[gԍ */
struct	sockaddr_in	serversockaddr;	/* NTPT[õAhX */

HWND ServerEdit;					/* T[o͂GfBbg{bNX */
HWND hBTNGET;						/* ̎擾s{^ */
HWND hBTNSYNC;						/* 𓯊{^ */
HWND LocalEdit;						/* [J\GfBbg{bNX */
HWND NTPEdit;						/* NTP\GfBbg{bNX */

struct NTP_Packet{					/* NTPpPbg */
	int Control_Word;
	int root_delay;
	int root_dispersion;
	int reference_identifier;
	__int64 reference_timestamp;
	__int64 originate_timestamp;
	__int64 receive_timestamp;
	int transmit_timestamp_seconds;
	int transmit_timestamp_fractions;
};


/*---------------------------------------------------
	͂ꂽT[oƃpXo֐
---------------------------------------------------*/
int GetServerPort(char *buf,char *server)
{
	char *p,*r,*t,wk[8];		/* Ɨp̈ */
	int port = 123;

	if(strcmp(buf,"") == 0){
		return -1;
	}

	strcpy(server,buf);

	/* T[o:|[g ƂȂĂꍇ͕ */
	for(p = server;*p != ':' && *p != '\0';p++);
	if(*p == ':'){
		for(t = p + 1,r = wk;*t != '\0';t++,r++){
			*r = *t;
		}
		*r = '\0';
		port = atoi(wk);

		*p = '\0';
	}

	return port;
}


/*---------------------------------------------------
	\PbgCxg̒ʒmݒ肷֐
---------------------------------------------------*/
BOOL SocketSelect(int sSoc,HWND hWnd)
{
	/* M̃\PbgCxgʒm悤ɐݒ肷 */
	/* \PbgCxǵAEBhEWSOCK_SELECTbZ[WŒʒm悤ɐݒ肷 */
	if(WSAAsyncSelect(sSoc, hWnd, WSOCK_SELECT, FD_READ) == SOCKET_ERROR){
		return FALSE;
	}
	return TRUE;
}

/*---------------------------------------------------
	T[oɃAhXIPAhXƃ|[gԍݒ肷
---------------------------------------------------*/
void SetSockaddr(unsigned long cIPaddr,int cPort)
{

	/* T[õAhX̍\̂ɃT[oIPAhXƃ|[gԍݒ肵܂ */
	serversockaddr.sin_family	= AF_INET;
	serversockaddr.sin_addr.s_addr = cIPaddr;						/* IPAhX */
	serversockaddr.sin_port		= htons((unsigned short)cPort);		/* |[gԍ */
	memset(serversockaddr.sin_zero,(int)0,sizeof(serversockaddr.sin_zero));
}

/*---------------------------------------------------
	NTPpPbg𑗐M
---------------------------------------------------*/
BOOL SendSNTPPacket(int sSoc)
{
	struct NTP_Packet	NTP_Send;				/* MNTPpPbg */

	/* NTPpPbgSNTPpɏ */
	NTP_Send.Control_Word = htonl(0x0B000000);
	NTP_Send.root_delay = 0;
	NTP_Send.root_dispersion = 0;
	NTP_Send.reference_identifier = 0;
	NTP_Send.reference_timestamp = 0;
	NTP_Send.originate_timestamp = 0;
	NTP_Send.receive_timestamp = 0;
	NTP_Send.transmit_timestamp_seconds = 0;
	NTP_Send.transmit_timestamp_fractions = 0;

	/* T[ow肵NTPpPbg𑗐M */
	if(sendto(sSoc,(const char *)&NTP_Send, sizeof( NTP_Send ),0,(struct sockaddr *)&serversockaddr,sizeof(serversockaddr)) == SOCKET_ERROR){
		return FALSE;
	}
	return TRUE;
}

/*---------------------------------------------------
	\Pbgj֐
---------------------------------------------------*/
void SocketClose(HWND hWnd)
{
	/* ^CAEgp̃^C}[j */
	KillTimer(hWnd,TIMER_ID);

	/* WSAAsyncGetHostByName֐̔񓯊ȃ^XNꍇ̓LZ */
	if(hGetHost != NULL){
		WSACancelAsyncRequest(hGetHost);
		hGetHost = NULL;
	}
	/* \PbgCxg̒ʒm */
	WSAAsyncSelect(soc, hWnd, 0,0);
	/* \Pbgj */
	closesocket(soc);
	soc = -1;

	if(sync_flag == FALSE){
		SetWindowText(hBTNGET,"GET");
	}else{
		SetWindowText(hBTNSYNC,"SYNC");
	}
}

/*---------------------------------------------------
	\Pbg̃G[֐
---------------------------------------------------*/
void SocketError(HWND hWnd,char *msgbuf)
{
	/* \Pbgj */
	SocketClose(hWnd);

	/* G[bZ[W */
	MessageBox(hWnd,msgbuf,"Error",MB_OK | MB_ICONERROR);

}

/*---------------------------------------------------
	SNTPZbV̊Jn
---------------------------------------------------*/
void SNTPStart(HWND hWnd,char *buf)
{
	unsigned long serveraddr;		/* T[oIPAhX */

	/* ͕T[oƃpX擾 */
	Port = GetServerPort(buf,SvName);
	if(Port == -1){
		MessageBox(hWnd, "T[o͂Ă܂B", "Error", MB_OK | MB_ICONERROR);
		if(sync_flag == FALSE){
			SetWindowText(hBTNGET,"GET");
		}else{
			SetWindowText(hBTNSYNC,"SYNC");
		}
		return;
	}
	/* socɃ\Pbg쐬܂ */
	soc = socket(PF_INET, SOCK_DGRAM, 0);
	if(soc == INVALID_SOCKET){
		MessageBox(hWnd, "Socket̍쐬Ɏs܂B", "Error", MB_OK | MB_ICONERROR);
		soc = -1;
		if(sync_flag == FALSE){
			SetWindowText(hBTNGET,"GET");
		}else{
			SetWindowText(hBTNSYNC,"SYNC");
		}
		return;
	}

	/* svNameɃhbgŋ؂10iIPAhXĂꍇAserveraddr32bitIPAhXԂ܂ */
	serveraddr = inet_addr((char*)SvName);
	if(serveraddr == -1){
		/* T[oT[õzXg擾 */
		/* zXg񂪎擾łƁAEBhEWSOCK_GETHOSTʒm悤ɂ */
		hGetHost = WSAAsyncGetHostByName(hWnd,WSOCK_GETHOST,SvName,gHostEnt, MAXGETHOSTSTRUCT);
		if(hGetHost == 0){
			SocketError(hWnd,"T[oIPAhX̎擾Ɏs܂B");
			return;
		}
		return;
	}
	/* ڑAMAؒf̃CxgEBhEbZ[WŒʒm悤ɂ */
	if(SocketSelect(soc, hWnd) == FALSE){
		SocketError(hWnd,"SocketCxgʒmݒɎs܂B");
		return;
	}

	SetSockaddr(serveraddr,Port);

	if(SendSNTPPacket(soc) == FALSE){
		SocketError(hWnd,"MɎs܂B");
		return;
	}

	/* ^CAEgp̃^C}[Zbg */
	SetTimer(hWnd, TIMER_ID, 3000, NULL);

}

/*---------------------------------------------------
	IPAhX擾ăf[^𑗐M
---------------------------------------------------*/
void GetHostToIPaddr(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	struct hostent FAR *HostEntry;	/* zXg */
	unsigned long serveraddr;		/* T[oIPAhX */

	/* G[̔ */
	if(WSAGETASYNCERROR(lParam) != 0){
		SocketError(hWnd,"T[oIPAhX̎擾Ɏs܂B");
		return;
	}
	/* WSAAsyncGetHostByName̖߂lł񓯊ȃ^XÑnh*/
	if(hGetHost != (HANDLE)wParam){
		return;
	}
	HostEntry = (struct hostent FAR *)gHostEnt;
	serveraddr =  *((unsigned long *)((HostEntry->h_addr_list)[0]));	/* IPAhX擾 */

	hGetHost = NULL;

	/* \PbgCxgEBhEbZ[WŒʒm悤ɂ */
	if(SocketSelect(soc, hWnd) == FALSE){
		SocketError(hWnd,"SocketCxgʒmݒɎs܂B");
		return;
	}

	SetSockaddr(serveraddr,Port);

	if(SendSNTPPacket(soc) == FALSE){
		SocketError(hWnd,"MɎs܂B");
		return;
	}

	/* ^CAEgp̃^C}[Zbg */
	SetTimer(hWnd, TIMER_ID, 3000, NULL);

}

/*---------------------------------------------------
	SNTP̃f[^M
---------------------------------------------------*/
void SNTPRecvData(HWND hWnd)
{
	struct NTP_Packet	NTP_Recv;				/* MNTPpPbg */
	int sockaddr_Size;							/* T[õAhX̃TCY */
	char buf[BUFSIZE];

	time_t Cur_time;							/* [J}V̎ */
	time_t ntp_time;							/* NTPT[o擾 */
	struct tm *lpNewLocalTime;					/* nɕϊNTPT[o̎ */
	SYSTEMTIME	Timecall;						/* [J}Vɐݒ肷鎞 */
	float	Splitseconds;

	/* T[ow肵ĎMs */
	sockaddr_Size = sizeof(serversockaddr);
	if(recvfrom(soc, (char *)&NTP_Recv, sizeof(NTP_Recv), 0,(struct sockaddr *)&serversockaddr,&sockaddr_Size) == SOCKET_ERROR ){
		SocketError(hWnd,"MɎs܂B");
		return;
	}
	/* \Pbgj */
	SocketClose(hWnd);

	/* [J}V̎擾 */
	Cur_time = time(NULL);

	/* NTPT[o擾nԂɕϊ */
	ntp_time = ntohl(NTP_Recv.transmit_timestamp_seconds) - 2208988800;		/* 1970/01/01 ̕bɕϊ */
	lpNewLocalTime = localtime((unsigned int *)&ntp_time);
	if(lpNewLocalTime == NULL){
		MessageBox(hWnd,"̎擾Ɏs܂B","Error",MB_OK | MB_ICONERROR);
		return;
	}

	/* tOĂꍇ́A̓s */
	if(sync_flag == TRUE){
		/* [J̌vZ */
		Timecall.wYear = lpNewLocalTime->tm_year + 1900;
		Timecall.wMonth = lpNewLocalTime->tm_mon + 1;
		Timecall.wDay = lpNewLocalTime->tm_mday;
		Timecall.wHour = lpNewLocalTime->tm_hour;
		Timecall.wMinute = lpNewLocalTime->tm_min;
		Timecall.wSecond = lpNewLocalTime->tm_sec;

		Splitseconds = (float)ntohl(NTP_Recv.transmit_timestamp_fractions);
		Splitseconds = (float)0.000000000200 * Splitseconds;
		Splitseconds = (float)1000.0 * Splitseconds;
		Timecall.wMilliseconds = (unsigned short)Splitseconds;

		/* [JNTPT[o擾ɐݒ肷 */
		if(SetLocalTime(&Timecall) == FALSE){
			MessageBox(hWnd,"̐ݒɎs܂B","Error",MB_OK | MB_ICONERROR);
		}else{
			MessageBox(hWnd,"NTPT[o̎ɓ܂B","info",MB_OK | MB_ICONINFORMATION);
		}
	}
	/* [J\ */
	wsprintf(buf,"%s",ctime((unsigned int *)&Cur_time));
	buf[strlen(buf) - 1] = '\0';
	SendMessage(LocalEdit,WM_SETTEXT,0,(LPARAM) ((LPSTR)buf));

	/* NTPT[o擾\ */
	wsprintf(buf,"%s",ctime((unsigned int *)&ntp_time));
	buf[strlen(buf) - 1] = '\0';
	SendMessage(NTPEdit,WM_SETTEXT,0,(LPARAM) ((LPSTR)buf));

}

/*---------------------------------------------------
	CEBhẼvV[W
---------------------------------------------------*/
LONG APIENTRY  MainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char buf[BUFSIZE];

	switch (uMsg)
	{
	case WM_CREATE:		/* EBhE쐬 */
		/* EBhẼRg[쐬 */
		CreateWindow("STATIC",(LPSTR)"Server:",WS_CHILD | WS_VISIBLE,5,10,50,25,hWnd,(HMENU)NULL,g_hinst,NULL);
		CreateWindow("STATIC",(LPSTR)"Local:",WS_CHILD | WS_VISIBLE,5,50,50,25,hWnd,(HMENU)NULL,g_hinst,NULL);
		CreateWindow("STATIC",(LPSTR)"NTP:",WS_CHILD | WS_VISIBLE,5,80,50,25,hWnd,(HMENU)NULL,g_hinst,NULL);
		ServerEdit = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT",(LPSTR)NULL,WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_AUTOHSCROLL,60,10,300,25,hWnd,(HMENU)ID_EDIT_SERVER,g_hinst,NULL);
		LocalEdit = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT",(LPSTR)NULL,WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_AUTOHSCROLL | ES_READONLY,60,50,420,25,hWnd,(HMENU)ID_EDIT_CUR,g_hinst,NULL);
		NTPEdit = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT",(LPSTR)NULL,WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_AUTOHSCROLL | ES_READONLY,60,80,420,25,hWnd,(HMENU)ID_EDIT_NTP,g_hinst,NULL);
		hBTNGET = CreateWindow("BUTTON",(LPSTR)"GET",WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,370,10,50,25,hWnd,(HMENU)ID_GET,g_hinst,NULL);
		hBTNSYNC = CreateWindow("BUTTON",(LPSTR)"SYNC",WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,430,10,50,25,hWnd,(HMENU)ID_SYNC,g_hinst,NULL);
		SetFocus(ServerEdit);
		/*  */
		soc = -1;
		hGetHost = NULL;

		break;

	case WSOCK_GETHOST:						/* T[õzXg֐̃Cxg */
		/* zXg񂩂IPAhX擾ĐڑJn */
		GetHostToIPaddr(hWnd,wParam,lParam);
		break;

	case WSOCK_SELECT:						/* \PbgCxg̃bZ[W̏ꍇ(WSAAsyncSelect֐ɂēo^) */
		/* G[̔ */
		if(soc != -1 && WSAGETSELECTERROR(lParam) != 0){
			SocketError(hWnd,"SocketCxg̒ʒmŃG[܂B");
			break;
		}
		/* ׂ\Pbg */
		if(soc != (int)wParam){
			break;
		}
		/* M̃Cxg̏ꍇ͏s */
		if(WSAGETSELECTEVENT(lParam) == FD_READ){
			/* f[^M */
			SNTPRecvData(hWnd);
		}
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case ID_GET:			/* 擾{^ꂽƂ̏ */
			if(soc != -1){		/* ɒʐM̏ꍇ̓LZ */
				/* \Pbgj */
				SocketClose(hWnd);
			}else{				/* ʐMJn */
				/* T[o擾 */
				SendMessage(ServerEdit,WM_GETTEXT,BUFSIZE - 1,(LPARAM)buf);
				SetWindowText(hBTNGET,"Cancel");
				/* tOUɐݒ肷 */
				sync_flag = FALSE;
				/* SNTTPZbVJn */
				SNTPStart(hWnd,buf);
			}
			break;

		case ID_SYNC:			/* {^ꂽƂ̏ */
			if(soc != -1){		/* ɒʐM̏ꍇ̓LZ */
				/* \Pbgj */
				SocketClose(hWnd);
			}else{				/* ʐMJn */
				/* T[o擾 */
				SendMessage(ServerEdit,WM_GETTEXT,BUFSIZE - 1,(LPARAM)buf);
				SetWindowText(hBTNSYNC,"Cancel");
				/* tO^ɐݒ肷 */
				sync_flag = TRUE;
				/* SNTPZbVJn */
				SNTPStart(hWnd,buf);
			}
			break;
		}
		break;

	case WM_TIMER:				/* ^CAEg̏ */
		if(wParam == TIMER_ID){
			/* ^CAEg̃bZ[W\ */
			SocketError(hWnd,"^CAEg܂B");
			break;
		}
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_ENDSESSION:
		return 0;

	case WM_CLOSE:
		/* ʐM̏ꍇ̓LZ */
		if(soc != -1){
			/* \Pbgj */
			SocketClose(hWnd);
		}

		/* EBhEj */
		DestroyWindow(hWnd);
		break;

	default:
		return (DefWindowProc(hWnd, uMsg, wParam, lParam));
	}
	return(0);

}

/*---------------------------------------------------
	WinSock̏s֐
---------------------------------------------------*/
BOOL initWinsock(void)
{
	WORD wVersionRequested;
	int  nErrorStatus;
    WSADATA wsaData;

	wVersionRequested = MAKEWORD(1, 1);				/* o[W 1.1 v */
	nErrorStatus = WSAStartup(wVersionRequested, &wsaData);
    if (atexit((void (*)(void))(WSACleanup))) {		/* IWinSock̃\[X悤ɂĂ */
		MessageBox(NULL, "WinSock̏Ɏs܂B", "Error", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	if ( nErrorStatus != 0 ) {
		MessageBox(NULL, "WinSock̏Ɏs܂B", "Error", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	return TRUE;
}

/*---------------------------------------------------
	EBhENX̓o^s֐
---------------------------------------------------*/
BOOL InitApplication(HANDLE hInstance)
{
	WNDCLASS  wc;

	/* EBhENXo^ */
	wc.style = 0;
	wc.lpfnWndProc = (WNDPROC)MainProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICONMAIN));
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (void*)COLOR_BTNSHADOW;
	wc.lpszMenuName =  MAKEINTRESOURCE(200);
	wc.lpszClassName = "sntpexMainWindowClass";

	return (RegisterClass(&wc));
}

/*---------------------------------------------------
	EBhE̍쐬s֐
---------------------------------------------------*/
BOOL InitInstance( HANDLE hInstance, int nCmdShow)
{
	HWND hWnd;
	RECT DeskTopRect;

	GetWindowRect(GetDesktopWindow(),(LPRECT)&DeskTopRect);

	hWnd = CreateWindow("sntpexMainWindowClass",
		"snptcex Ver 0.0",
		WS_CAPTION | WS_DLGFRAME | WS_POPUP | WS_SYSMENU | WS_MINIMIZEBOX,
		(DeskTopRect.right / 2) - (500 / 2),
		(DeskTopRect.bottom / 2) - (140 / 2),
		500,
		140,
		NULL,
		NULL,
		g_hinst,
		NULL
		);

	if (!hWnd){
		return (FALSE);
	}

	/* EBhE\ */
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

    return (TRUE);

}

/*---------------------------------------------------
	C֐
---------------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	g_hinst = hInstance;

	/* WinSock̏s */
	if (!initWinsock()) {
		return FALSE;
	}

	/* EBhENX̓o^s */
	if (!InitApplication(hInstance)){
		return (FALSE);
	}
    /* EBhE̍쐬s */
	if (!InitInstance(hInstance, nCmdShow)){
		return (FALSE);
	}

	/* EBhEbZ[W */
	while (GetMessage(&msg,NULL,0,0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (msg.wParam);

}

